//+------------------------------------------------------------------+
//|                                               Juice_mod_v1.2.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                                                 Written by IgorAD|   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//|        Thanks Perky for Idea: http://fxovereasy.atspace.com/index|
//|   Updated method for count avg juice bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"
//---- indicator settings
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  DeepSkyBlue
#property indicator_color2  LimeGreen
#property indicator_color3  Red   
#property indicator_color4  LimeGreen  
#property indicator_color5  Orange
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_style5  STYLE_DOT
//---- indicator parameters
extern int    Length     = 7;
extern double Ks         = 1.0;
extern int    CalcBars   = 144;
extern int    Advance    = 70; 
extern double juiceLevel = 0.0007;

//---- indicator buffers

double upBuffer[];
double dnBuffer[];
double juhuu[];
double juhud[];
double juhdd[];
double juhdu[];
double trend[];
double slope[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(7);
   SetIndexBuffer(0,juhuu);    SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,juhud);    SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,juhdd);    SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,juhdu);    SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,dnBuffer); SetIndexShift(4,Advance);
   SetIndexBuffer(5,upBuffer);
   SetIndexBuffer(6,trend);
   
   IndicatorShortName("Juice mod v2("+Length+","+DoubleToStr(Ks,2)+")");
   return(0);
  }
//+------------------------------------------------------------------+
//| Juice_mod_v1.2                                                   |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
          limit = MathMin(Bars-counted_bars,Bars-1);
          
   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      if (CalcBars==0) int NBars=Bars-Length; else NBars=CalcBars;
      double sum=0;
      for(int j=(i+NBars); j>=i; j--) sum+=iStdDev(NULL,0,Length,MODE_EMA,0,PRICE_CLOSE,j);
         
         upBuffer[i] = iStdDev(NULL,0,Length,MODE_EMA,0,PRICE_CLOSE,i);
         dnBuffer[i] = Ks*sum/NBars;
         
         //
         //
         //
         //
         //
         
         juhuu[i] = EMPTY_VALUE;
         juhud[i] = EMPTY_VALUE;
         juhdd[i] = EMPTY_VALUE;
         juhdu[i] = EMPTY_VALUE;

         
         trend[i] = trend[i+1];
         if (upBuffer[i] > upBuffer[i+1]) trend[i] = 1;
         if (upBuffer[i] < upBuffer[i+1]) trend[i] =-1;
         if (upBuffer[i] > juiceLevel)
           if (trend[i] == 1) 
                juhuu[i] = upBuffer[i];
           else juhud[i] = upBuffer[i]; 
         if (upBuffer[i] < juiceLevel)
           if (trend[i] ==-1) 
                juhdd[i] = upBuffer[i];
           else juhdu[i] = upBuffer[i];
            
   }
return(0);
}
//+------------------------------------------------------------------+

